VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4185
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   3345
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4185
   ScaleWidth      =   3345
   Begin VB.CommandButton cmdShowValues 
      Caption         =   "Show Values"
      Height          =   495
      Left            =   1080
      TabIndex        =   1
      Top             =   3600
      Width           =   1215
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const NUM_ROWS = 10
Private Const NUM_COLS = 4
Private Const MAX_ROW = NUM_ROWS - 1
Private Const MAX_COL = NUM_COLS - 1

Private strings() As String

' Show the values in the Debug window.
Private Sub cmdShowValues_Click()
Dim r As Integer
Dim c As Integer

    For r = 0 To MAX_ROW
        For c = 0 To MAX_COL
            Debug.Print strings(r, c) & ", ";
        Next c
        Debug.Print
    Next r
End Sub

Private Sub Form_Load()
Const GAP = 60
Dim X As Single
Dim Y As Single
Dim wid As Single
Dim hgt As Single
Dim r As Integer
Dim c As Integer
Dim i As Integer

    ' Make a string array to match the TextBoxes.
    ReDim strings(0 To MAX_ROW, 0 To MAX_COL)

    ' Create and position the controls.
    X = Text1(0).Left
    Y = Text1(i).Top
    wid = Text1(i).Width
    hgt = Text1(i).Height

    ' Create the controls.
    For i = 1 To NUM_ROWS * NUM_COLS - 1
        Load Text1(i)
        If i Mod NUM_COLS = 0 Then
            ' Start a new row.
            X = Text1(0).Left
            Y = Y + hgt + GAP
        Else
            X = X + wid + GAP
        End If
        Text1(i).Move X, Y, wid, hgt
        Text1(i).Visible = True
        Text1(i).Text = i
    Next i

    Text1(0).Text = "0"
End Sub

' Update the corresponding string.
Private Sub Text1_Change(Index As Integer)
Dim r As Integer
Dim c As Integer

    r = Index \ NUM_COLS
    c = Index Mod NUM_COLS
    strings(r, c) = Text1(Index).Text
End Sub


' Change the color of the TextBox just to verify
' that our row and column calculations are right.
Private Sub Text1_Click(Index As Integer)
Dim r As Integer
Dim c As Integer

    r = Index \ NUM_COLS
    c = Index Mod NUM_COLS
    Index = r * NUM_COLS + c

    If Text1(Index).ForeColor = vbBlack Then
        Text1(Index).ForeColor = vbRed
    Else
        Text1(Index).ForeColor = vbBlack
    End If
End Sub

